/*
 
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev             
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
                                           
  VIRtUal Soft         All rights reserved 
 
  
*/

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <iostream.h>
#include <math.h>

#define g 9.81

float cTheta,			// Current Theta
  g_L,				// g / L
  Theta0,			// Initial Theta
  w,				// Omega
  t,				// Stop limit
  h,				// Delta t
  m,				// Mass
  L,				// Length
  E0,				// Initial Eps
  cE,				// Current Eps
  c,				// Iterator
  dur,				// Durability
  k[4];
  char graph;

float
E ()
{
  return m * L * ((L * w * w) / 2. + g * (1. - cosf (cTheta)));
}

void
Initiate ()
{
  w = 0.;
  c = 0.;
  L = g / g_L;
  cTheta = Theta0;
}

void
Calculate ()
{
  k[0] = -g_L * sinf (cTheta);
  k[1] = -g_L * sinf (cTheta + (h * w) / 5. + (h * h * k[0]) / 50.);
  k[2] =
    -g_L * sinf (cTheta + (2. * h * w) / 3. +
		h * h * ((-1. / 27.) * k[0] + (7. / 27.) * k[1]));
  k[3] =
    -g_L * sinf (cTheta + h * w +
		h * h * ((3. / 10.) * k[0] - (2. / 35.) * k[1] -
			 (9. / 35.) * k[2]));

  cTheta +=
    h * w + h*h * ((14. / 336.) * k[0] + (100. / 336.) * k[1] +
		      (54. / 336.) * k[2]);
  w +=
    h * ((14. / 336.) * k[0] + (125. / 336.) * k[1] + (162. / 336.) * k[2] +
	     (35. / 336.) * k[3]);
}

int
main ()
{
  char *output = new char[255];
  cin >> output;
  cin >> m;
  cin >> g_L;
  cin >> Theta0;
  cin >> t;
  do
    {
      cin >> h;
    }
  while (h > t);		// Prevent wrong step
  cin >> dur;
  cin >> graph;

  FILE *f;
  f = fopen (output, "w");
  Initiate ();

  E0 = E ();
  printf ("E0: %f\n", E0);

  while (c <= t)
    {
      fprintf (f, "%f %f\n", c, (graph == '1')? w : cTheta);
      if (1 - fabs (E () / E0) > dur)
	{
	  // ReOpen file
	  fclose (f);
	  f = fopen (output, "w");
	  h /= 2.;
	  printf ("Reinitiate h = %f\n", h);
	  Initiate ();
	}
      Calculate ();
      c += h;
    }
  fclose (f);
  delete output;
  return 0;
}
